#!/usr/bin/perl -w

use strict;

if($ARGV[0]) {
	my $i = 0;
	foreach(@ARGV) {
		if($_ eq '-h' || $_ eq '--help') {
			print_usage();
			exit;
		}
		$i++;
	}
}

my $txt     = '';
while(<STDIN>) {
	$txt .= $_;
}

if($txt eq '') {
	print "No input!\n";
	exit;
}

my $qd = "<queue_dump>\n";

#qd released 6 February 2005 (fr 028)
if($txt =~ /qd released (.*?) \(fr (.*?)\)/) {
	$qd .= "  <qd>\n";
	$qd .= "    <date>$1</date>\n";
	$qd .= "    <functional_revision>$2</functional_revision>\n";
	$qd .= "  </qd>\n";
}

#qd info 6 February 2005 (rph)
if($txt =~ /qd info (.*)/) {
	$qd .= "  <qdinfo>$1</qdinfo>\n";
}
	$qd .= "  <queue>\n";

#Queue version 5.01
if($txt =~ /Queue version (\d+\.\d+.*?)/) {
	$qd .= "    <version>$1</version>\n";
}

#Current index: 9
if($txt =~ /Current index: (\d+)/) {
	$qd .= "    <current_index>$1</current_index>\n";
}
	
# Index 0: finished 302.00 pts (8.529 pt/hr) 22.4 X min speed
#  server: 171.65.103.154:8080; project: 1322
#  Folding: run 0, clone 494, generation 1; benchmark 1384; misc: 500, 400
#  issue: Fri Jan  7 03:10:50 2005; begin: Fri Jan  7 03:25:03 2005
#  end: Sat Jan  8 14:49:35 2005; due: Wed Feb  9 03:25:03 2005 (33 days)
#  core URL: http://www.stanford.edu/~pande/Linux/x86/Core_78.fah
#  assignment info (le): Fri Jan  7 03:10:49 2005; A2288C4C
#  CS: 171.65.103.100; P limit: 52427776
#  user: [DPC]_Fatal_Error_Group0smoking2000; team: 92; ID: 637FFF483558C82F; mach ID: 1
#  work/wudata_00.dat file size: 862570; WU type: Folding@Home

my $key  = '';
my $open = 0;
foreach(split /\r?\n/, $txt) {
	# Index 9: folding now
	# Index 0: finished
	if(/Index (\d+): (empty|deleted|finished|garbage|folding now|queued for processing|ready for upload|DANGER will be lost if client is restarted!|abandoned|fetching from server|UNKNOWN STATUS = \S+)/) {
			$key = $1;
		
		if($open == 1) {
			$qd .= "    </index>\n";
		}
		$qd .= "    <index>\n";
		$qd .= "      <number>$1</number>\n";
		$qd .= "      <status>$2</status>\n";
		
		$open = 1;
	}

	#302.00 pts
	if(/(\d+(\.\d+)?) pts/) {
		$qd .= "      <credit>$1</credit>\n";
	}
	#(8.529 pt/hr)
	if(/\((\d+(\.\d+)?) pt\/hr\)/) {
		$qd .= "      <credit_per_hour>$1</credit_per_hour>\n";
	}
	#7.23 X min speed
	if(/(\d+(\.\d+)?) X min speed/) {
		$qd .= "      <progress_rate>$1</progress_rate>\n";
	}
	#69% complete
	if(/(\d+(\.\d+)?%) complete/) {
		$qd .= "      <progress>$1</progress>\n";
	}
	
		#server: 171.65.103.154:8080
	if(/server: (\d+\.\d+\.\d+\.\d+(:\d+)?)/) {
		$qd .= "      <server>\n";
		$qd .= "        <number>1</number>\n";
		$qd .= "        <address>$1</address>\n";
		$qd .= "      </server>\n";
	}
	#server 1: 171.65.103.154
	if(/server (1): (\d+\.\d+\.\d+\.\d+(:\d+)?)/) {
		$qd .= "      <server>\n";
		$qd .= "        <number>$1</number>\n";
		$qd .= "        <address>$2</address>\n";
		$qd .= "      </server>\n";
	}
	#server 2: 171.65.103.154:8080
	if(/server (2): (\d+\.\d+\.\d+\.\d+(:\d+)?)/) {					
		$qd .= "      <server>\n";
		$qd .= "        <number>$1</number>\n";
		$qd .= "        <address>$2</address>\n";
		$qd .= "      </server>\n";
	}
		#project: 1322, "p1475_tet1_03_1"
	if(/project: (\d+), "(.*?)"/) {
		$qd .= "      <project_number>$1</project_number>\n";
		$qd .= "      <project_name>$2</project_name>\n";
	}
	#project: 1322
	elsif(/project: (\d+)/) {
		$qd .= "      <project_number>$1</project_number>\n";
	}
	
	#Genome: unit 36476, 7554, 656; misc: 500, 400; 500, 400
	if(/Genome: unit (\d+, \d+, \d+); misc: (\d+, \d+); (\d+, \d+)/) {
		$qd .= "      <genome>\n";
		$qd .= "        <unit>$1</unit>\n";
		$qd .= "        <misc>$2</misc>\n";
		$qd .= "        <other>$3</other>\n";
		$qd .= "      </genome>\n";
	}
	#Genome: unit 36476, 7554, 656; benchmark 1384; misc: 500, 400
	elsif(/Genome: unit (\d+, \d+, \d+); benchmark (\d+); misc: (\d+, \d+)/) {
		$qd .= "      <genome>\n";
		$qd .= "        <unit>$1</unit>\n";
		$qd .= "        <benchmark>$2</benchmark>\n";
		$qd .= "        <misc>$3</misc>\n";
		$qd .= "      </genome>\n";
	}

	#Folding: run 0, clone 494, generation 1; benchmark 1384; misc: 500, 400
	if(/Folding: run (\d+), clone (\d+), generation (\d+); benchmark (\d+); misc: (\d+, \d+)/) {
		$qd .= "      <folding>\n";
		$qd .= "        <run>$1</run>\n";
		$qd .= "        <clone>$2</clone>\n";
		$qd .= "        <generation>$3</generation>\n";
		$qd .= "        <benchmark>$4</benchmark>\n";
		$qd .= "        <misc>$5</misc>\n";
		$qd .= "      </folding>\n";
	}
	#Folding: run 0, clone 494, generation 1; misc: 500, 400, 500, 400
	elsif(/Folding: run (\d+), clone (\d+), generation (\d+); misc: (\d+, \d+); (\d+, \d+)/) {
		$qd .= "      <folding>\n";
		$qd .= "        <run>$1</run>\n";
		$qd .= "        <clone>$2</clone>\n";
		$qd .= "        <generation>$3</generation>\n";
		$qd .= "        <misc>$4</misc>\n";
		$qd .= "        <other>$5</other>\n";
		$qd .= "      </folding>\n";
	}
	#issue: Fri Jan 28 10:06:08 2005
	#issue: Fri Jan  7 03:10:50 2005
	if(/issue: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <issue_timestamp>$1</issue_timestamp>\n";
	}

	#begin: Fri Jan  7 03:25:03 2005
	if(/begin: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <begin_timestamp>$1</begin_timestamp>\n";
	}
	
	#end: Wed Apr 20 11:21:54 2005 (10 hours)
	if(/end: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+) \((.*?) (days|hours|minutes)\)/) {
		$qd .= "      <end_timestamp>$1</end_timestamp>\n";
		$qd .= "      <end_in>$2 $3</end_in>\n";
	}
	#end: Tue Feb  1 20:56:19 2005
	elsif(/end: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <end_timestamp>$1</end_timestamp>\n";
	}

	#due: Wed Apr 20 11:21:54 2005 (82 days)
	#due: Wed Apr 20 11:21:54 2005 (10 hours)
	if(/due: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+) \((.*?) (days|hours|minutes)\)/) {
		$qd .= "      <due_timestamp>$1</due_timestamp>\n";
		$qd .= "      <due_in>$2 $3</due_in>\n";
	}
	#due: Wed Apr 20 11:21:54 2005
	elsif(/due: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <due_timestamp>$1</due_timestamp>\n";
	}
			
	#expire: Wed Apr 20 11:21:54 2005 (82 days)
	#expire: Wed Apr 20 11:21:54 2005 (10 hours)
	if(/expire: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+) \((.*?) (days|hours|minutes)\)/) {
		$qd .= "      <expire_timestamp>$1</expire_timestamp>\n";
		$qd .= "      <expire_in>$2 $3</expire_in>\n";
	}
	#expire: Wed Apr 20 11:21:54 2005
	elsif(/expire: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <expire_timestamp>$1</expire_timestamp>\n";
	}
			
	#expect: Wed Apr 20 11:21:54 2005 (10 hours)
	if(/expect: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+) \((.*?) (days|hours|minutes)\)/) {
		$qd .= "      <expect_timestamp>$1</expect_timestamp>\n";
		$qd .= "      <expect_in>$2 $3</expect_in>\n";
	}
	#expect: Wed Feb  9 01:33:16 2005
	elsif(/expect: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <expect_timestamp>$1</expect_timestamp>\n";
	}
			
	#core URL: http://www.stanford.edu/~pande/Linux/x86/Core_78.fah (V1.70)
	if(/core URL: (.*) \(V(.*?)\)$/) {
		$qd .= "      <core>\n";
		$qd .= "        <url>$1</url>\n";
		$qd .= "        <version>$2</version>\n";
		$qd .= "      </core>\n";
	}
	#core URL: http://www.stanford.edu/~pande/Linux/x86/Core_78.fah
	#core URL: MISSING
	elsif(/core URL: (.*)/) {
		$qd .= "      <core>\n";
		$qd .= "        <url>$1</url>\n";
		$qd .= "      </core>\n";
	}

	#CPU: 1,0 x86
	#CPU: 1,2000 AMD x86
	#CPU: 1,87 Pentium IV
	if(/(CPU): (\d+),(\d+) (.*);/i) {
		$qd .= "      <$1>\n";
		$qd .= "        <cosm_type>$2</cosm_type>\n";
		$qd .= "        <cosm_subtype>$3</cosm_subtype>\n";
		$qd .= "        <name>$4</name>\n";
		$qd .= "      </$1>\n";
	}
	#CPU: 1,87
	elsif(/(CPU): (\d+),(\d+)/) {
		$qd .= "      <$1>\n";
		$qd .= "        <cosm_type>$2</cosm_type>\n";
		$qd .= "        <cosm_subtype>$3</cosm_subtype>\n";
		$qd .= "      </$1>\n";
	}

	#OS: 4,0 Linux
	#OS: 1,8 WinXP
	#OS: 1,9 Win2K3
	if(/(OS): (\d+),(\d+) (.*)/i) {
		$qd .= "      <$1>\n";
		$qd .= "        <cosm_type>$2</cosm_type>\n";
		$qd .= "        <cosm_subtype>$3</cosm_subtype>\n";
		$qd .= "        <name>$4</name>\n";
		$qd .= "      </$1>\n";
	}
	#OS: 1,9
	elsif(/(OS): (\d+,\d+)/) {
		$qd .= "      <$1>\n";
		$qd .= "        <cosm_type>$2</cosm_type>\n";
		$qd .= "        <cosm_subtype>$3</cosm_subtype>\n";
		$qd .= "      </$1>\n";
	}

	#assignment info (le): Fri Jan  7 03:10:49 2005; A2288C4C
	#assignment info (be): Fri Jan  7 03:10:49 2005; A2288C4C
	if(/assignment info \((le|be)\): (.*?); (.*)/) {
		$qd .= "      <assignment_info>\n";
		$qd .= "        <byte_order>$1</byte_order>\n";
		$qd .= "        <timestamp>$2</timestamp>\n";
		$qd .= "        <checksum>$3</checksum>\n";
		$qd .= "      </assignment_info>\n";
	}

	#CS: 171.67.89.100
	if(/CS: (\d+\.\d+\.\d+\.\d+)/) {
		$qd .= "      <collection_server>$1</collection_server>\n";
	}
				
	#DL: Sat Sep 18 01:47:09 2004
	if(/DL: (\w+\s+\w+\s+\d+\s+\d+:\d+:\d+\s+\d+)/) {
		$qd .= "      <download_timestamp>$1</download_timestamp>\n";
	}

	#upload failures: 1
	if(/upload failures: (\d+)/) {
		$qd .= "      <upload_failures>$1</upload_failures>\n";
	}

	#P limit: 52427776
	if(/P limit: (\d+)/) {
		$qd .= "      <packet_size_limit>$1</packet_size_limit>\n";
	}

	#(qgen)
	if(/\((qgen)\)/) {
		$qd .= "      <tag>$1</tag>\n";
	}

	#user: [DPC]_Fatal_Error_Group0smoking2000; team: 92; ID: 637FFF483558C82F; mach ID: 1
	if(/user: (.*?);/) {
		$qd .= "      <username>$1</username>\n";
	}
	elsif(/user: (.*)/) {
		$qd .= "      <username>$2</username>\n";
	}
				
	if(/; team: (.*?);/) {
		$qd .= "      <team>$1</team>\n";
	}
	elsif(/; team: (.*)/) {
		$qd .= "      <team>$1</team>\n";
	}
				
	if(/; ID: (.*?);/) {
		$qd .= "      <id>$1</id>\n";
	}
	elsif(/; ID: (.*)/) {
		$qd .= "      <id>$1</id>\n";
	}
				
	if(/; mach ID: (.*)/) {
		$qd .= "      <machine_id>$1</machine_id>\n";
	}
				
	#work/wudata_00.dat file size: 862570; WU type: Folding@Home
	if(/(work\/wudata_\d+.dat) file size: (\d+); WU type: (Folding\@Home|.*)/) {
		$qd .= "      <work_unit>\n";
		$qd .= "        <file>$1</file>\n";
		$qd .= "        <size>$2</size>\n";
		$qd .= "        <type>$3</type>\n";
		$qd .= "      </work_unit>\n";
	}
	#work/wudata_00.dat file size: 862570
	elsif(/(work\/wudata_\d+.dat) file size: (\d+)/) {
		$qd .= "      <work_unit>\n";
		$qd .= "        <file>$1</file>\n";
		$qd .= "        <size>$2</size>\n";
		$qd .= "      </work_unit>\n";
	}
}
$qd .= "    </index>\n" if($open == 1);

#Average download rate 175.261 KB/s (u=4)
if($txt =~ /Average download rate (\d+\.\d+ KB\/s) \(u=(\d+)\)/) {
	$qd .= "    <download_rate>\n";
	$qd .= "      <speed>$1</speed>\n";
	$qd .= "      <units>$2</units>\n";
	$qd .= "    </download_rate>\n";
}

#upload rate 34.042 KB/s (u=4)
if($txt =~ /upload rate (\d+\.\d+ KB\/s) \(u=(\d+)\)/) {
	$qd .= "    <upload_rate>\n";
	$qd .= "      <speed>$1</speed>\n";
	$qd .= "      <units>$2</units>\n";
	$qd .= "    </upload_rate>\n";
}

#Performance fraction 0.954537 (u=4)
if($txt =~ /Performance fraction (\d+\.\d+) \(u=(\d+)\)/) {
	$qd .= "    <performance_fraction>\n";
	$qd .= "      <fraction>$1</fraction>\n";
	$qd .= "      <units>$2</units>\n";
	$qd .= "    </performance_fraction>\n";
}

#Average pph: 6.194, ppd: 148.65, ppw: 1040.5, ppy: 54292
if($txt =~ /Average pph: (\d+\.\d+), ppd: (\d+\.\d+), ppw: (\d+\.\d+), ppy: (\d+)/) {
	$qd .= "    <pph>$1</pph>\n";
	$qd .= "    <ppd>$2</ppd>\n";
	$qd .= "    <ppw>$3</ppw>\n";
	$qd .= "    <ppy>$4</ppy>\n";
}
$qd .= "  </queue>\n";
$qd .= "</queue_dump>\n";				

print $qd;

sub print_usage {
	print "Usage: $0 < qd-output-file\n\n";
	print "qd2xml will convert normal qd ouput to its XML form.\n\n";
	print "The commands below for instance will result in the same output:\n";
	print "\$ qd -x\n";
	print "\$ qd | qd2xml.pl\n";
	print "\$ qd2xml.pl < qd";
}
